'Part of FRACCOL for PowerBASIC and QBASIC

'Robert Seidel rseidel@ifk.uni-jena.de
'http://www.uni-jena.de/~p6sepa/rshp.html

' MVKM-Iteration
' aus Buch Bausteine des Chaos - FRAKTALE
' von Pleitgen , Saupe , Jrgens

SCREEN 12
DIM xlinks(10) , xrechts(10) , xoben(10)
DIM ylinks(10) , yrechts(10) , yoben(10)
DIM a(3) , b(3) , c(3) , d(3) , e(3) , f(3)
INPUT" Stufe eingeben : ", stufe
links = 0
w = 480
wl = w + links
xlinks(stufe)  = 0
ylinks(stufe)  = 0
xrechts(stufe) = w
yrechts(stufe) = 0
xoben(stufe)   = 0.5 * w
yoben(stufe)   = w

' Parameter :
a(1) = .5     :   a(2) = .5     :   a(3) = .5
b(1) =  0     :   b(2) =  0     :   b(3) =  0
c(1) =  0     :   c(2) =  0     :   c(3) =  0
d(1) = .5     :   d(2) = .5     :   d(3) = .5
e(1) =  0     :   e(2) = .5 * w :   e(3) = .25 * w
f(1) =  0     :   f(2) =  0     :   f(3) = .5 * w

GOSUB 100
END

' transformiere das Dreieck
50  xlinks(stufe)  = a(abb) * xlinks(stufe + 1)  + e(abb)
    ylinks(stufe)  = d(abb) * ylinks(stufe + 1)  + f(abb)
    xrechts(stufe) = a(abb) * xrechts(stufe + 1) + e(abb)
    yrechts(stufe) = d(abb) * yrechts(stufe + 1) + f(abb)
    xoben(stufe)   = a(abb) * xoben(stufe + 1)   + e(abb)
    yoben(stufe)   = d(abb) * yoben(stufe + 1)   + f(abb)

' zeichne Dreieck auf der niedrigsten Sufe
100 IF stufe > 1 THEN GOTO 200
    LINE(links + xlinks(1), wl - ylinks(1)) -(links + xrechts(1) , wl - yrechts(1))
    LINE - (links + xoben(1) , wl - yoben(1))
    LINE - (links + xlinks(1) , wl - ylinks(1))
    GOTO 300

' verzweige in niedrigere Stufe
200 DECR stufe
    abb = 1
    GOSUB 50
    abb = 2
    GOSUB 50
    abb = 3
    GOSUB 50
    INCR stufe

300 RETURN


