'Part of FRACCOL for PowerBASIC and QBASIC

'Robert Seidel rseidel@ifk.uni-jena.de
'http://www.uni-jena.de/~p6sepa/rshp.html

DECLARE SUB SetPal (j%)
DECLARE SUB Subdivide (x1%, y1%, x2%, y2%)
DECLARE SUB NewCol (xa%, ya%, x%, y%, xb%, yb%)
DECLARE SUB SetRGB (Nr%, r%, g%, b%)

' Plasmagenerator fr QBASIC
' von Robert Seidel

DEFINT A-Z
CONST Rauheit! = 2
RANDOMIZE TIMER
SCREEN 13

SetPal 0
CALL Subdivide(0, 0, 320, 199)
WHILE INKEY$ = ""
 SetPal (j)
 j = j + 1
 FOR tmp = 0 TO 600  ' unbedingt auf Rechner abstimmen !
 NEXT
WEND
SCREEN 0

SUB NewCol (xa, ya, x, y, xb, yb)
 col = ABS(xa - xb) + ABS(ya - yb)
 col = RND * Rauheit! * col - col
 col = (col + POINT(xa, ya) + POINT(xb, yb)) \ 2
 IF col < 1 THEN col = 1
 IF col > 180 THEN col = 1
 IF POINT(x, y) = 0 THEN PSET (x, y), col
END SUB

SUB SetPal (j)
 FOR i = 1 TO 63
  CALL SetRGB(i + j, 0, 63 - i, i)
  CALL SetRGB(i + 63 + j, i, 0, 63 - i)
  CALL SetRGB(i + 126 + j, 63 - i, i, 0)
 NEXT
END SUB

SUB SetRGB (Nr, r, g, b)
 OUT &H3C8, Nr
 OUT &H3C9, r
 OUT &H3C9, g
 OUT &H3C9, b
END SUB

SUB Subdivide (x1, y1, x2, y2)
 IF NOT (x2 - x1 < 2 AND y2 - y1 < 2) THEN
  x = (x1 + x2) \ 2
  y = (y1 + y2) \ 2
  NewCol x1, y1, x, y1, x2, y1
  NewCol x2, y1, x2, y, x2, y2
  NewCol x1, y2, x, y2, x2, y2
  NewCol x1, y1, x1, y, x1, y2
  col = POINT(x1, y1) + POINT(x2, y1) + POINT(x2, y2) + POINT(x1, y2)
  col = col \ 4
  PSET (x, y), col
  Subdivide x1, y1, x, y
  Subdivide x, y1, x2, y
  Subdivide x, y, x2, y2
  Subdivide x1, y, x, y2
 END IF
END SUB

