'Part of FRACCOL for PowerBASIC and QBASIC

'Robert Seidel rseidel@ifk.uni-jena.de
'http://www.uni-jena.de/~p6sepa/rshp.html

SCREEN 12

' gute Werte :  real :      imag :
'                0.1         0.5
'                0.05        0.3 .. 0.5
'                1.0         1.0
'                1.3         1.3
'                1.5 .. 2.0  1.5 .. 2.0

a = 640
b = 480
xmin = -3
xmax =  3
ymin = -2
ymax =  2
PRINT "  BLACKHOLE V1.00 von R.Seidel   "
?
PRINT " BLACKHOLE - zeigt das Verhalten "
PRINT " eines Raumschiffs in der Nhe   "
PRINT " zweier schwarzen Lcher.        "
PRINT " Da das Triebwerk des Raumschiffs"
PRINT " aber einen Widerstand entgegen- "
PRINT " setzt, entstehen interessante   "
PRINT " Flugbahnen !                    "
?
PRINT " komplexe Funktion : f(z) = z^2 - 1 "
?
?
INPUT " Korrektur real     (0 - 2) : ", u
INPUT " Korrektur imaginr (0 - 2) : ", v
INPUT " Startpunkt x , y           : ",i ,j
dx = (xmax - xmin)/a
dy = (ymax - ymin)/b
CLS
PSET(i,j)
x = xmin + i * dx
y = ymin + j * dy
start:
q = 2 * (x * x + y * y)
xn = (u * x + v * y)/q + x/2 * (2 - u) + y * v/2
y = (v * x - u * y)/q - v * x/2 + y/2 * (2 - u)
x = xn
i = (x - xmin)/dx
j = (y - ymin)/dy
PSET(i,j)
IF INKEY$ = "" THEN GOTO start
